﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<MyObject> objs = new List<MyObject>();
            objs.Add(new MyObject() { Id = 0, Count = 10 });
            objs.Add(new MyObject() { Id = 1, Count = 20 });
            objs.Add(new MyObject() { Id = 2, Count = 30 });

            List<MyProperty> props = new List<MyProperty>();
            props.Add(new MyProperty() { Id = 0, Name = "prop0" });
            props.Add(new MyProperty() { Id = 1, Name = "prop1" });
            props.Add(new MyProperty() { Id = 2, Name = "prop2" });

            List<Data> source = new List<Data>();
            source.Add(new Data() { Name = "data0", Objects = objs, Properties = props });
            source.Add(new Data() { Name = "data1", Objects = objs, Properties = props });
            source.Add(new Data() { Name = "data2", Objects = objs, Properties = props });

            this.DataContext = source;

        }

        private void XamDataGrid_RecordExpanding(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandingEventArgs e)
        {
            if (e.Record.ParentRecord == null)
            {
                foreach (var item in e.Record.ViewableChildRecords)
                {
                    item.IsExpanded = true;
                }
            }
        }

    }

    public class MyProperty
    {
        public int Id { get; set; }
        public string Name { get; set; }
    }

    public class MyObject
    {
        public int Id { get; set; }
        public int Count { get; set; }
    }

    public class Data
    {
        public string Name { get; set; }
        public List<MyProperty> Properties { get; set; }
        public List<MyObject> Objects { get; set; }
    }
}

